<?php
/***************************************************************
 * Copyright notice
 *
 * (c) 2010 Tolleiv
 * All rights reserved
 *
 * This script is part of the TYPO3 project. The TYPO3 project is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 *
 * This script is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

/**
 * Class tx_languagevisibility_hooks_tslib_menu
 *
 * @package AOE\Languagevisibility\Hooks
 */
class tx_languagevisibility_hooks_tslib_menu implements \TYPO3\CMS\Frontend\ContentObject\Menu\AbstractMenuFilterPagesHookInterface {

	/**
	 * Checks if a page is OK to include in the final menu item array.
	 *
	 * @param array $data
	 * @param array $banUidArray
	 * @param $spacer
	 * @param TYPO3\CMS\Frontend\ContentObject\Menu\AbstractMenuContentObject $obj
	 * @return bool
	 */
	public function tslib_menu_filterMenuPagesHook(array &$data, array $banUidArray, $spacer, \TYPO3\CMS\Frontend\ContentObject\Menu\AbstractMenuContentObject $obj) {
		if ($data['_NOTVISIBLE']) {
			return FALSE;
		} else {
			return TRUE;
		}
	}

	/**
	 * Checks if a page is OK to include in the final menu item array.
	 *
	 * @param array $data
	 * @param array $banUidArray
	 * @param bool $spacer
	 * @param TYPO3\CMS\Frontend\ContentObject\Menu\AbstractMenuContentObject $obj
	 * @return bool
	 */
	public function processFilter(array &$data, array $banUidArray, $spacer, \TYPO3\CMS\Frontend\ContentObject\Menu\AbstractMenuContentObject $obj) {
		return $this->tslib_menu_filterMenuPagesHook($data, $banUidArray, $spacer, $obj);
	}
}
